#
#	Makefile -- Build instructions for user level apps
#

.EXPORT_ALL_VARIABLES:
.PHONY: config all romfs clean prune

#
# Include architecture specific build rules.
#

ifndef ROOTDIR
ROOTDIR=..
endif

UCLINUX_BUILD_USER=1
-include $(LINUX_CONFIG)
-include $(CONFIG_CONFIG)
-include $(ARCH_CONFIG)
-include $(MODULES_CONFIG)
-include $(SDK_CONFIG)

VEND=$(ROOTDIR)/vendors


ifeq ($(CONFIG_IPV6),y)
CFLAGS += -DINET6
 ifneq ($(CONFIG_PROC_SYSCTL),y)
	$(error "CONFIG_PROC_SYSCTL option must be turned on in kernel menuconfig")
 endif
endif

#
# must run the vendor build first
#
dir_v = $(VEND)/$(CONFIG_VENDOR)/$(CONFIG_PRODUCT)/.
dir_p = $(ROOTDIR)/prop

dir_y = 
dir_n =
dir_  =

dir_y          	+= busybox
dir_y			+= mtd-utils-1.5.2

all: config
	$(MAKE) -j$(HOST_NCPU) $(sort $(dir_y))|| exit $$?

#
# add directory dependancies here
#
.PHONY: $(sort $(dir_y) $(dir_p))
snort: mysql

$(sort $(dir_y) $(dir_p)):  config
	[ ! -d "$@" ] || ( touch $@/.sgbuilt_user && $(MAKE) -j1 -C $@ ) || exit $$?

%_only:
	touch $(@:_only=)/.sgbuilt_user && $(MAKE) -j1 -C $(@:_only=)

%_clean:
	$(MAKE) -j1 -C $(@:_clean=) clean; rm -f $(@:_clean=)/.sgbuilt_user; true

romfs:
	for i in $(sort $(dir_y)) $(dir_p) ; do \
		[ ! -d $$i ] || $(MAKE) -C $$i romfs || exit $$? ; \
	done

clean:	
	-for i in $(dir_v) $(sort $(dir_y) $(dir_n) $(dir_)) $(dir_p) ; do \
		if [ -f $$i/.sgbuilt_user ]; then \
			$(MAKE) -C $$i clean ; \
			rm -f $$i/.sgbuilt_user; \
		fi; \
	done

prune:
	-for i in $(sort $(dir_n) $(dir_)) ; do \
		found=0; \
		for j in $(sort $(dir_y)) ; do \
			if [ $$i = $$j ]; then \
				found=1; \
			fi; \
		done; \
		if [ $$found = 0 ]; then \
			[ "$$i" = "freeswan" ] && make prune_freeswan; \
			[ "$$i" = "openswan" ] && make prune_openswan; \
			rm -fr $$i; \
		fi; \
	done

prune_freeswan:
	@cd $(ROOTDIR); \
	mkdir $@; \
	cp --parents freeswan/klips/net/ipsec/Config.in $@/; \
	rm -fr freeswan; \
	cp -R $@/* .; \
	rm -fr $@

prune_openswan:
	@cd $(ROOTDIR); \
	mkdir $@; \
	cp --parents openswan/linux/net/ipsec/{Config.in*,Kconfig,Makefile*,aes/Makefile*,des/Makefile*} $@/; \
	rm -fr openswan; \
	cp -R $@/* .; \
	rm -fr $@

